diff --git a/cmd/bdinfo.c b/cmd/bdinfo.c
index e30d530411..c6096a5fd3 100644
--- a/cmd/bdinfo.c
+++ b/cmd/bdinfo.c
@@ -15,7 +15,7 @@
 
 DECLARE_GLOBAL_DATA_PTR;
 
-static void print_num(const char *name, ulong value)
+void bdinfo_print_num(const char *name, ulong value)
 {
 	printf("%-12s= 0x%0*lx\n", name, 2 * (int)sizeof(value), value);
 }
@@ -38,7 +38,7 @@ static void print_lnum(const char *name, unsigned long long value)
 	printf("%-12s= 0x%.8llX\n", name, value);
 }
 
-static void print_mhz(const char *name, unsigned long hz)
+void bdinfo_print_mhz(const char *name, unsigned long hz)
 {
 	char buf[32];
 
@@ -52,9 +52,9 @@ static void print_bi_dram(const bd_t *bd)
 
 	for (i = 0; i < CONFIG_NR_DRAM_BANKS; ++i) {
 		if (bd->bi_dram[i].size) {
-			print_num("DRAM bank",	i);
-			print_num("-> start",	bd->bi_dram[i].start);
-			print_num("-> size",	bd->bi_dram[i].size);
+			bdinfo_print_num("DRAM bank",	i);
+			bdinfo_print_num("-> start",	bd->bi_dram[i].start);
+			bdinfo_print_num("-> size",	bd->bi_dram[i].size);
 		}
 	}
 #endif
@@ -70,50 +70,50 @@ int do_bdinfo(cmd_tbl_t *cmdtp, int flag, int argc, char *const argv[])
 	bd_t *bd = gd->bd;
 
 #ifdef DEBUG
-	print_num("bd address", (ulong)bd);
+	bdinfo_print_num("bd address", (ulong)bd);
 #endif
 	if (IS_ENABLED(CONFIG_ARM))
-		print_num("arch_number", bd->bi_arch_number);
-	print_num("boot_params", (ulong)bd->bi_boot_params);
+		bdinfo_print_num("arch_number", bd->bi_arch_number);
+	bdinfo_print_num("boot_params", (ulong)bd->bi_boot_params);
 	print_bi_dram(bd);
-	print_num("memstart", (ulong)bd->bi_memstart);
+	bdinfo_print_num("memstart", (ulong)bd->bi_memstart);
 	print_lnum("memsize", (u64)bd->bi_memsize);
-	print_num("flashstart", (ulong)bd->bi_flashstart);
-	print_num("flashsize", (ulong)bd->bi_flashsize);
-	print_num("flashoffset", (ulong)bd->bi_flashoffset);
+	bdinfo_print_num("flashstart", (ulong)bd->bi_flashstart);
+	bdinfo_print_num("flashsize", (ulong)bd->bi_flashsize);
+	bdinfo_print_num("flashoffset", (ulong)bd->bi_flashoffset);
 	printf("baudrate    = %u bps\n", gd->baudrate);
-	print_num("relocaddr", gd->relocaddr);
-	print_num("reloc off", gd->reloc_off);
+	bdinfo_print_num("relocaddr", gd->relocaddr);
+	bdinfo_print_num("reloc off", gd->reloc_off);
 	printf("%-12s= %u-bit\n", "Build", (uint)sizeof(void *) * 8);
 	if (IS_ENABLED(CONFIG_CMD_NET)) {
 		printf("current eth = %s\n", eth_get_name());
 		print_eth(0);
 		printf("IP addr     = %s\n", env_get("ipaddr"));
 	}
-	print_num("fdt_blob", (ulong)gd->fdt_blob);
-	print_num("new_fdt", (ulong)gd->new_fdt);
-	print_num("fdt_size", (ulong)gd->fdt_size);
+	bdinfo_print_num("fdt_blob", (ulong)gd->fdt_blob);
+	bdinfo_print_num("new_fdt", (ulong)gd->new_fdt);
+	bdinfo_print_num("fdt_size", (ulong)gd->fdt_size);
 #if defined(CONFIG_LCD) || defined(CONFIG_VIDEO) || defined(CONFIG_DM_VIDEO)
-	print_num("FB base  ", gd->fb_base);
+	bdinfo_print_num("FB base  ", gd->fb_base);
 #endif
 
 	/* This section is used only by ARM */
 #ifdef CONFIG_ARM
 #ifdef CONFIG_SYS_MEM_RESERVE_SECURE
 	if (gd->arch.secure_ram & MEM_RESERVE_SECURE_SECURED) {
-		print_num("Secure ram",
+		bdinfo_print_num("Secure ram",
 			  gd->arch.secure_ram & MEM_RESERVE_SECURE_ADDR_MASK);
 	}
 #endif
 #ifdef CONFIG_RESV_RAM
 	if (gd->arch.resv_ram)
-		print_num("Reserved ram", gd->arch.resv_ram);
+		bdinfo_print_num("Reserved ram", gd->arch.resv_ram);
 #endif
 #if !(CONFIG_IS_ENABLED(SYS_ICACHE_OFF) && CONFIG_IS_ENABLED(SYS_DCACHE_OFF))
-	print_num("TLB addr", gd->arch.tlb_addr);
+	bdinfo_print_num("TLB addr", gd->arch.tlb_addr);
 #endif
-	print_num("irq_sp", gd->irq_sp);	/* irq stack pointer */
-	print_num("sp start ", gd->start_addr_sp);
+	bdinfo_print_num("irq_sp", gd->irq_sp);	/* irq stack pointer */
+	bdinfo_print_num("sp start ", gd->start_addr_sp);
 	/*
 	 * TODO: Currently only support for davinci SOC's is added.
 	 * Remove this check once all the board implement this.
@@ -131,17 +131,17 @@ int do_bdinfo(cmd_tbl_t *cmdtp, int flag, int argc, char *const argv[])
 	       CONFIG_VAL(SYS_MALLOC_F_LEN));
 #endif
 #if CONFIG_IS_ENABLED(MULTI_DTB_FIT)
-	print_num("multi_dtb_fit", (ulong)gd->multi_dtb_fit);
+	bdinfo_print_num("multi_dtb_fit", (ulong)gd->multi_dtb_fit);
 #endif
 #endif /* CONFIG_ARM */
 
 	/* This section is used only by ppc */
 #if defined(CONFIG_MPC8xx) || defined(CONFIG_E500)
-	print_num("immr_base", bd->bi_immr_base);
+	bdinfo_print_num("immr_base", bd->bi_immr_base);
 #endif
 	if (IS_ENABLED(CONFIG_PPC)) {
-		print_num("bootflags", bd->bi_bootflags);
-		print_mhz("intfreq", bd->bi_intfreq);
+		bdinfo_print_num("bootflags", bd->bi_bootflags);
+		bdinfo_print_mhz("intfreq", bd->bi_intfreq);
 #ifdef CONFIG_ENABLE_36BIT_PHYS
 		if (IS_ENABLED(CONFIG_PHYS_64BIT))
 			puts("addressing  = 36-bit\n");
@@ -151,32 +151,32 @@ int do_bdinfo(cmd_tbl_t *cmdtp, int flag, int argc, char *const argv[])
 		board_detail();
 	}
 #if defined(CONFIG_CPM2)
-	print_mhz("cpmfreq", bd->bi_cpmfreq);
-	print_mhz("vco", bd->bi_vco);
-	print_mhz("sccfreq", bd->bi_sccfreq);
-	print_mhz("brgfreq", bd->bi_brgfreq);
+	bdinfo_print_mhz("cpmfreq", bd->bi_cpmfreq);
+	bdinfo_print_mhz("vco", bd->bi_vco);
+	bdinfo_print_mhz("sccfreq", bd->bi_sccfreq);
+	bdinfo_print_mhz("brgfreq", bd->bi_brgfreq);
 #endif
 
 	/* This is used by m68k and ppc */
 #if defined(CONFIG_SYS_INIT_RAM_ADDR)
-	print_num("sramstart", (ulong)bd->bi_sramstart);
-	print_num("sramsize", (ulong)bd->bi_sramsize);
+	bdinfo_print_num("sramstart", (ulong)bd->bi_sramstart);
+	bdinfo_print_num("sramsize", (ulong)bd->bi_sramsize);
 #endif
 	if (IS_ENABLED(CONFIG_PPC) || IS_ENABLED(CONFIG_M68K))
-		print_mhz("busfreq", bd->bi_busfreq);
+		bdinfo_print_mhz("busfreq", bd->bi_busfreq);
 
 	/* The rest are used only by m68k */
 #ifdef CONFIG_M68K
 #if defined(CONFIG_SYS_MBAR)
 	print_num("mbar", bd->bi_mbar_base);
 #endif
-	print_mhz("cpufreq", bd->bi_intfreq);
+	bdinfo_print_mhz("cpufreq", bd->bi_intfreq);
 	if (IS_ENABLED(CONFIG_PCI))
-		print_mhz("pcifreq", bd->bi_pcifreq);
+		bdinfo_print_mhz("pcifreq", bd->bi_pcifreq);
 #ifdef CONFIG_EXTRA_CLOCK
-	print_mhz("flbfreq", bd->bi_flbfreq);
-	print_mhz("inpfreq", bd->bi_inpfreq);
-	print_mhz("vcofreq", bd->bi_vcofreq);
+	bdinfo_print_mhz("flbfreq", bd->bi_flbfreq);
+	bdinfo_print_mhz("inpfreq", bd->bi_inpfreq);
+	bdinfo_print_mhz("vcofreq", bd->bi_vcofreq);
 #endif
 #endif
 
diff --git a/include/init.h b/include/init.h
index b5a167b6ed..af4deed566 100644
--- a/include/init.h
+++ b/include/init.h
@@ -261,6 +261,12 @@ void relocate_code(ulong start_addr_sp, struct global_data *new_gd,
 	__attribute__ ((noreturn));
 #endif
 
+/* Print a numeric value (for use in arch_print_bdinfo()) */
+void bdinfo_print_num(const char *name, ulong value);
+
+/* Print a clock speed in MHz */
+void bdinfo_print_mhz(const char *name, unsigned long hz);
+
 #endif	/* __ASSEMBLY__ */
 /* Put only stuff here that the assembler can digest */
 