diff --git a/cmd/gpt.c b/cmd/gpt.c
index b8d11c167d..3263ac42df 100644
--- a/cmd/gpt.c
+++ b/cmd/gpt.c
@@ -15,6 +15,7 @@
 #include <malloc.h>
 #include <command.h>
 #include <part_efi.h>
+#include <part.h>
 #include <exports.h>
 #include <linux/ctype.h>
 #include <div64.h>
@@ -616,6 +617,135 @@ static int gpt_verify(struct blk_desc *blk_dev_desc, const char *str_part)
 	return ret;
 }
 
+/**
+ * gpt_enumerate() - Enumerate partition names into environment variable.
+ *
+ * Enumerate partition names. Partition names are stored in gpt_partition_list
+ * environment variable. Each partition name is delimited by space.
+ *
+ * @blk_dev_desc: block device descriptor
+ *
+ * @Return: '0' on success and 1 on failure
+ */
+static int gpt_enumerate(struct blk_desc *blk_dev_desc)
+{
+	struct part_driver *first_drv, *part_drv;
+	int str_len = 0, tmp_len;
+	char part_list[2048];
+	int n_drvs;
+	char *ptr;
+
+	part_list[0] = 0;
+	n_drvs = part_driver_get_count();
+	first_drv = part_driver_get(0);
+	if (!first_drv) {
+		printf("Failed to get partition driver\n");
+		return 1;
+	}
+
+	for (part_drv = first_drv; part_drv != first_drv + n_drvs; part_drv++) {
+		disk_partition_t pinfo;
+		int ret;
+		int i;
+
+		for (i = 1; i < part_drv->max_entries; i++) {
+			ret = part_drv->get_info(blk_dev_desc, i, &pinfo);
+			if (ret) {
+				/* no more entries in table */
+				break;
+			}
+
+			ptr = &part_list[str_len];
+			tmp_len = strlen((const char *)pinfo.name);
+			str_len += tmp_len;
+			if (str_len > sizeof(part_list)) {
+				printf("Error insufficient memory\n");
+				return -ENOMEM;
+			}
+			strncpy(ptr, (const char *)pinfo.name, tmp_len);
+			/* One byte for space(" ") delimiter */
+			strncpy(&ptr[tmp_len], " ", 1);
+			str_len++;
+		}
+	}
+	if (*part_list)
+		part_list[strlen(part_list) - 1] = 0;
+	debug("setenv gpt_partition_list %s\n", part_list);
+
+	return env_set("gpt_partition_list", part_list);
+}
+
+/**
+ * gpt_setenv() - Dynamically setup environment variables.
+ *
+ * Dynamically setup environment variables for name, index, offset and size
+ * for partition in GPT table after running "gpt setenv" for a partition name.
+ * gpt_partition_name, gpt_partition_entry, gpt_partition_addr and
+ * gpt_partition_size environment variables will be set.
+ *
+ * @blk_dev_desc: block device descriptor
+ * @name: partition name
+ *
+ * @Return: '0' on success and -ENOENT on failure
+ */
+static int gpt_setenv(struct blk_desc *blk_dev_desc, const char *name)
+{
+	struct part_driver *first_drv, *part_drv;
+	int n_drvs;
+
+	n_drvs = part_driver_get_count();
+	first_drv = part_driver_get(0);
+	if (!first_drv) {
+		printf("Failed to get partition driver\n");
+		return -ENOENT;
+	}
+
+	for (part_drv = first_drv; part_drv != first_drv + n_drvs; part_drv++) {
+		disk_partition_t pinfo;
+		char buf[32];
+		int ret;
+		int i;
+
+		for (i = 1; i < part_drv->max_entries; i++) {
+			ret = part_drv->get_info(blk_dev_desc, i, &pinfo);
+			if (ret) {
+				/* no more entries in table */
+				break;
+			}
+			if (strcmp(name, (const char *)pinfo.name) == 0) {
+				/* match found, setup environment variables */
+				sprintf(buf, LBAF, pinfo.start);
+				debug("setenv gpt_partition_addr %s\n", buf);
+				ret = env_set("gpt_partition_addr", buf);
+				if (ret)
+					return -ENOENT;
+
+				sprintf(buf, LBAF, pinfo.size);
+				debug("setenv gpt_partition_size %s\n", buf);
+				ret = env_set("gpt_partition_size", buf);
+				if (ret)
+					return -ENOENT;
+
+				sprintf(buf, "%d", i);
+				debug("setenv gpt_partition_entry %s\n", buf);
+				ret = env_set("gpt_partition_entry", buf);
+				if (ret)
+					return -ENOENT;
+
+				sprintf(buf, "%s", pinfo.name);
+				debug("setenv gpt_partition_name %s\n", buf);
+				ret = env_set("gpt_partition_name", buf);
+				if (ret)
+					return -ENOENT;
+
+				return 0;
+			}
+		}
+	}
+
+	return -ENOENT;
+}
+
 static int do_disk_guid(struct blk_desc *dev_desc, char * const namestr)
 {
 	int ret;
@@ -822,6 +952,10 @@ static int do_gpt(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
 	} else if ((strcmp(argv[1], "verify") == 0)) {
 		ret = gpt_verify(blk_dev_desc, argv[4]);
 		printf("Verify GPT: ");
+	} else if ((strcmp(argv[1], "setenv") == 0)) {
+		ret = gpt_setenv(blk_dev_desc, argv[4]);
+	} else if ((strcmp(argv[1], "enumerate") == 0)) {
+		ret = gpt_enumerate(blk_dev_desc);
 	} else if (strcmp(argv[1], "guid") == 0) {
 		ret = do_disk_guid(blk_dev_desc, argv[4]);
 #ifdef CONFIG_CMD_GPT_RENAME
@@ -852,7 +986,17 @@ U_BOOT_CMD(gpt, CONFIG_SYS_MAXARGS, 1, do_gpt,
 	" to interface\n"
 	" Example usage:\n"
 	" gpt write mmc 0 $partitions\n"
+	"    - write the GPT to device\n"
 	" gpt verify mmc 0 $partitions\n"
+	"    - verify the GPT on device against $partitions\n"
+	" gpt setenv mmc 0 $name\n"
+	"    - setup environment variables for partition $name:\n"
+	"      gpt_partition_addr, gpt_partition_size,\n"
+	"      gpt_partition_name, gpt_partition_entry\n"
+	" gpt enumerate mmc 0\n"
+	"    - store list of partitions to gpt_partition_list environment variable\n"
+	" read <interface> <dev>\n"
+	"    - read GPT into a data structure for manipulation\n"
 	" gpt guid <interface> <dev>\n"
 	"    - print disk GUID\n"
 	" gpt guid <interface> <dev> <varname>\n"
diff --git a/include/part.h b/include/part.h
index 3693527397..014f4164e7 100644
--- a/include/part.h
+++ b/include/part.h
@@ -9,6 +9,7 @@
 #include <blk.h>
 #include <ide.h>
 #include <uuid.h>
+#include <linker_lists.h>
 #include <linux/list.h>
 
 struct block_drvr {
@@ -474,5 +475,46 @@ int write_mbr_partition(struct blk_desc *dev_desc, void *buf);
 
 #endif
 
+#ifdef CONFIG_PARTITIONS
+/**
+ * part_driver_get_count() - get partition driver count
+ *
+ * @return - number of partition drivers
+ */
+static inline int part_driver_get_count(void)
+{
+	return ll_entry_count(struct part_driver, part_driver);
+}
+
+/**
+ * part_driver_get() - get partition driver
+ *
+ * Get the partition driver from the partition driver list for the
+ * requested partition driver count
+ *
+ * @param n - partition driver count
+ *
+ * @return - pointer to partition driver on success, otherwise NULL
+ */
+static inline struct part_driver *part_driver_get(int n)
+{
+	struct part_driver *first_drv;
+
+	if (n > part_driver_get_count()) {
+		printf("Invalid partition driver count (%d)\n", n);
+		return NULL;
+	}
+
+	first_drv = ll_entry_start(struct part_driver, part_driver);
+
+	return &first_drv[n];
+}
+#else
+static inline int part_driver_get_count(void)
+{ return 0; }
+
+static inline struct part_driver *part_driver_get(int n)
+{ return NULL; }
+#endif /* CONFIG_PARTITIONS */
 
 #endif /* _PART_H */